﻿; PWLib 1.0
; Author: TroaX
; Crossplattform Include

; Contants
#PWLib_NoSalt = ""
#PWLib_NoPepper = ""
#PWLib_WrongCipherDepth = "WDEPTH"
#PWLib_CipherDepth_128 = 128
#PWLib_CipherDepth_256 = 256
#PWLib_CipherDepth_384 = 384
#PWLib_CipherDepth_512 = 512

; Init CipherAlgorithm
UseSHA3Fingerprint()

; Basic Hash-Procedure
Procedure.s IterateHashing(pwstring.s,pepperstring.s,saltstring.s,shadepth.w,count.i)
  Define validdepth.i
  Select shadepth
    Case #PWLib_CipherDepth_128
      validdepth = #True
    Case #PWLib_CipherDepth_256
      validdepth = #True
    Case #PWLib_CipherDepth_384
      validdepth = #True
    Case #PWLib_CipherDepth_512
      validdepth = #True
    Default
      validdepth = #False
  EndSelect 
  If validdepth
    Define hashedstring.s
    hashedstring = StringFingerprint(pepperstring + pwstring + saltstring,#PB_Cipher_SHA3,shadepth)
    If count > 0
      Define x.i
      For x = 0 To count
        hashedstring = StringFingerprint(hashedstring + Str(x),#PB_Cipher_SHA3,shadepth)
      Next
    EndIf
  Else
    ProcedureReturn #PWLib_WrongCipherDepth
  EndIf
  ProcedureReturn hashedstring
EndProcedure

; Generate Random String without Specialchars
Procedure.s GenerateRandomString(length.i)
  Define ReturnString.s = ""
  Dim ranchar.c(2)
  Define x.i
  For x = 1 To length
    ranchar(0) = Random(57,48)
    ranchar(1) = Random(90,65)
    ranchar(2) = Random(122,97)
    ReturnString = ReturnString + Chr(ranchar(Random(2,0)))
  Next
  ProcedureReturn ReturnString
EndProcedure

; Compare Password and Hashstring
Procedure.i ComparePassword(hashstring.s,pwstring.s,pepperstring.s,shadepth.w,count.i)
  Define hashpart.s = StringField(hashstring,1,".")
  Define saltpart.s = StringField(hashstring,2,".")
  Define hashedstring.s = IterateHashing(pwstring,pepperstring,saltpart,shadepth,count)
  If hashedstring = hashpart
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

; Compare Password and Hashstring with Pepperlist
Procedure.i ComparePasswordPepperlist(hashstring.s,pwstring.s,shadepth.w,count.i,Array Pepperlist.s(1))
  Define hashpart.s = StringField(hashstring,1,".")
  Define saltpart.s = StringField(hashstring,2,".")
  Define pepperlistsize.i = ArraySize(Pepperlist())
  Define x.i
  For x = 0 To pepperlistsize
    Define hashedstring.s = IterateHashing(pwstring,Pepperlist(x),saltpart,shadepth,count)
    If hashedstring = hashpart
      ProcedureReturn #True
    EndIf
  Next
  ProcedureReturn #False
EndProcedure

; Hash-Procedure with inserted Salt
Procedure.s HashPassword(pwstring.s,pepperstring.s,saltstring.s,shadepth.w,count.i)
  If saltstring = #PWLib_NoSalt
    ProcedureReturn IterateHashing(pwstring,pepperstring,saltstring,shadepth,count)
  Else
    ProcedureReturn IterateHashing(pwstring,pepperstring,saltstring,shadepth,count) + "." + saltstring
  EndIf
EndProcedure

; Hash-Procedure to extends the Basic-Procedure with a Papperlist
Procedure.s HashPasswordPepperlist(pwstring.s,saltstring.s,shadepth.w,count.i, Array Pepperlist.s(1))
  If ArraySize(Pepperlist()) > 0
    Define size.i = ArraySize(Pepperlist())
    Define randomentry.i = Random(size,0)
  Else
    randomentry.i = 0
  EndIf
  If saltstring = #PWLib_NoSalt
    ProcedureReturn IterateHashing(pwstring,Pepperlist(randomentry),saltstring,shadepth,count)
  Else
    ProcedureReturn IterateHashing(pwstring,Pepperlist(randomentry),saltstring,shadepth,count) + "." + saltstring
  EndIf
EndProcedure

; Generate a Random Pepperlist
Procedure GeneratePepperlist(Array Pepperlist.s(1),stringlength.i)
  Define listsize.i = ArraySize(Pepperlist())
  Define x.i
  For x = 0 To listsize
    Pepperlist(x) = GenerateRandomString(stringlength)
  Next
EndProcedure
; IDE Options = PureBasic 5.40 LTS (Windows - x64)
; CursorPosition = 114
; FirstLine = 69
; Folding = --
; EnableUnicode
; EnableXP